//Just switch Focal_Blur on/off to see and check the difference...
#declare Focal_Blur=off;


#include "bsplines.inc" //We're using BSplines
#include "meshes.inc" //We're using meshes
#include "x_over.inc" //We're using a cross-over from the former 2
#include "memo_array.inc" //We need to memorize
#include "look_at.inc"

global_settings{assumed_gamma 1 max_trace_level 20}

#declare Petal_Texture=texture{pigment{rgb x*.8} finish{specular .05 roughness .2 brilliance 1.3}}
#declare TPetal_Texture=texture{pigment{rgb x*.8} finish{specular .05 roughness .2 brilliance 1.3}}
#declare Green_Texture=texture{pigment{rgb <.02,.01,0>} finish{specular .02 roughness .1}}
#declare Seed_Texture=texture{pigment{rgb <.2,.05,0>} finish{specular .02 roughness .1}}
#declare Base_Texture=texture{pigment{rgb y*.5} normal{bozo .2 no_bump_scale scale <.2,1,.2>} finish{specular .14 roughness .05 brilliance 2.3}}

#declare Mesh_Type=1;
#include "pieces.pov"

#declare Petal=object{Petal texture{Petal_Texture}}
#declare TPetal=object{TPetal texture{TPetal_Texture}}
#declare Base=object{Base texture{Base_Texture}}

//#declare Petal_Texture=texture{pigment{rgb .1} finish{reflection 1}}
sky_sphere{pigment{gradient y color_map{[0 rgb .5][1 rgb z*.2]}scale 2 translate -1}}
disc{y*-15,y,7 pigment{rgb .9} finish{specular .5 roughness .04}}

#declare Gerb_Rand=seed(050580);

#declare Gerbera=union{

difference{
 sphere{0,1 scale <2.1,.3,2.1> texture{Base_Texture}}
 sphere{0,1 texture{Petal_Texture}
  scale <1.25,.1,1.25> translate y*.25
  }
} 

#declare Seed_Obj=
union{
 sphere{0,.1 scale <1,1,2> translate z*-.5}
 cylinder{0,z*-.5,.05}
 texture{Seed_Texture}
 scale .5
 }

#declare SeedHold_Obj=sphere{0,1 scale <.85,.1,.85> translate y*.25
 //texture{Green_Texture}
 }
sphere{0,1 scale <.85,.1,.85> translate y*.25
 texture{Green_Texture}
 }

#declare Amount=120;
#declare A=0;
#while (A<Amount)
 //Create an angle, and then calculate the distance
 #declare Pos=vrotate(<1,0,0>,y*360/.618*A)*sqrt(A/Amount)*.7;
 //Find position on spherical object
 #declare Normal=<0,0,0>;
 #declare New_Pos=trace(SeedHold_Obj, Pos+y*4, -y, Normal);
 //#declare Pos_a=1-sqrt( pow(Pos.x,2)+pow(Pos.z,2) );
 //Place seed
 object{Seed_Obj
  rotate Look_At(Normal)
  translate New_Pos 
 }
 #declare A=A+1;
#end


#declare Mem_Val=0;
#declare Memorize=array[3]
Init_Memo_Array(Memorize,Mem_Val)
#declare Max_Angle = 40;
#declare Angle_Dif=10;

#declare Petal_Amount = 50;
//Large outside petals
#declare C=0;
#while (C<=Petal_Amount)
 object{Petal
  scale 1+.1*(rand(Gerb_Rand)*2-1)
  rotate -x*Do_Memo_Array(Memorize,Mem_Val,Max_Angle,Angle_Dif)
  translate y*.2*(rand(Gerb_Rand)*2-1)
  translate z*(1.8+.2*(rand(Gerb_Rand)*2-1))
  rotate y*(360/Petal_Amount*C+360/Petal_Amount/5*(rand(Gerb_Rand)*2-1))
  }
#declare C=C+1;
#end


//The tiny inside-petals
/*
#declare TPetal_Amount = 800;
#declare C=0;
#while (C<TPetal_Amount)
 #declare Outwards=sqrt(rand(Gerb_Rand));
 object{TPetal
  scale (.15+.05*Outwards) //(rand(Gerb_Rand)*2-1) 
  rotate x*(-80+50*rand(Gerb_Rand)) 
  translate z*(.25+Outwards*1.25) 
  rotate y*(360/Petal_Amount*C+10*rand(Gerb_Rand))
  }
#declare C=C+1;
#end
*/

#declare TPetal_Amount=500;
#declare A=0;
#while (A<TPetal_Amount)
 //Create an angle, and then calculate the distance
 #declare Pos=vrotate(<1,0,0>,y*360/.618*A)*sqrt(A/TPetal_Amount);
 #declare Outwards=vlength(Pos);
 //Find position on spherical object
 //#declare Normal=<0,0,0>;
 //#declare New_Pos=trace(SeedHold_Obj, Pos+y*4, -y, Normal);
 //#declare Pos_a=1-sqrt( pow(Pos.x,2)+pow(Pos.z,2) );
 //Place seed
 object{TPetal
  scale (.15+.15*Outwards)
  rotate <-90+(30*rand(Gerb_Rand)+Outwards*20),180,0>
  rotate Look_At(Pos)
  translate vnormalize(Pos)*(.25+Outwards*1.25)
  //rotate y*(360/Petal_Amount*C+10*rand(Gerb_Rand))
  }
 #declare A=A+1;
#end

//The base-petals
#declare Base_Amount = 35;
#declare C=0;
#while (C<Base_Amount)
 #declare Outwards=sqrt(rand(Gerb_Rand));
 object{Base
  scale .5
  translate y*-.3
  //translate z*-1 scale (.15+.05*Outwards)*<1,1,2> //(rand(Gerb_Rand)*2-1) 
  rotate -x*10
  translate z*(.125+.65*Outwards) 
  rotate y*(360/Base_Amount*C+10*rand(Gerb_Rand))
  }
#declare C=C+1;
#end
}

#declare Gerb_Rot=<-50,20,0>;

#declare Gerbera_Stem_Dat=array[4]
{ <0,-15,0>,<0,4,0>,
  <0,0,0>,vrotate(<0,7,0>,Gerb_Rot)
  }

union{
 Show_BSpline(Gerbera_Stem_Dat,.4,200)
 texture{Base_Texture}
 }

object{Gerbera translate y*.25 rotate Gerb_Rot}

light_source{<-100,300,-200> rgb 1
 area_light x*70,y*70,20,20 circular orient adaptive .65
 }


//Normal perspective, entire flower in view
camera{location <0,5,-26> look_at <0,-5,0>
 //#if (Focal_Blur)
  //focal_point <0,0,0> aperture .65 blur_samples 40
 //#end
}


//Close-Up
//camera{location <0,3,-8> look_at <0,0,0>}
